<?php

/**
 * @file
 *   drush integration for Archibald 2
 */

require_once dirname(__FILE__) . "/../../includes/Lom.class.php";
require_once dirname(__FILE__) . "/../../includes/LomSaveHandler.class.php";

/**
 * Implements hook_drush_command().
 *
 * In this hook, you specify which commands your
 * drush module makes available, what it does and
 * description.
 *
 * Notice how this structure closely resembles how
 * you define menu hooks.
 *
 * @see drush_parse_command()
 *   for a list of recognized keys.
 *
 * @return
 *   An associative array describing your command(s).
 */
function archibald_import_drush_command() {
  $items = array();
  $items['archibald_import_test'] = array(
    'description' => "test archibald lom class",
    'arguments' => array(
      'action' => 'the plugin (mark21_fritic for example)',
      'index' => 'the position to import',
    ),
    'callback' => 'drush_archibald_import_test',
  );
  return $items;
}

/**
 * imports the given resource position from the given plugin

 *
 * @param string $plugin
 *  the plugin
 * @param string $index
 *  the position
 */
function drush_archibald_import_test() {
  $args   = func_get_args();
  $plugin = @$args[0];
  $index = @$args[1];

  if (file_exists(ARCHIBALD_IMPORT_PATH . 'plugins/' . $plugin . '.class.php')) {
    require_once ARCHIBALD_IMPORT_PATH . 'plugins/' . $plugin . '.class.php';
    $classname = 'Archibald';
    foreach (explode('_', $plugin) AS $module_part) {
      $classname .= drupal_ucfirst($module_part);
    }

    $_SESSION['archibald_import_class'] = $classname;
    $_SESSION['archibald_import_class_file'] = $plugin;

    /* @var $module_instance ArchibaldImport */
    $module_instance = new $classname();
    $module_instance->import($index);

  }

}