(function ($) {
  Drupal.behaviors.archibald_ratings_star = {
    attach: function (context, settings) {
      $('.archibald_ratings_star').unbind('click');
      $('.archibald_ratings_star').bind('click', archibald_ratings_add);
      function archibald_ratings_add() {
        $.ajax({
          type: 'POST',
          url: $(this).attr('url'),
          success: function(response, status) {
            $('#archibald_ratings_help_text').text(response.message);

            $('#archibald_ratings_help_text').show();

            rating_sinular_plural = Drupal.t('Rating');
            if(response.new_count > 1) {
              rating_sinular_plural = Drupal.t('Ratings');
            }

            $('.archibald_ratings_star').attr('title', Drupal.t('Actual rating: @value of 5 points', {
              '@value': response.new_rating.toString()
              }) +
            ' ' + Drupal.t('at')  + ' ' + response.new_count.toString() + ' ' + rating_sinular_plural);

            $('#archibald_ratings_stars').removeClass().addClass('rating ' + response.css_class);

            // Remove classes so that user can not try to rate directly a second time.
            $('#archibald_ratings_stars li').removeClass('star');
            $('.archibald_ratings_star').removeClass();
          },
          dataType: 'json'
        });
      };
      $('.archibald_ratings_star').bind('mouseout', archibald_ratings_show_default_text);
      function archibald_ratings_show_default_text() {
        $('#archibald_ratings_help_text').hide();
      };
    }
  }
})(jQuery);
