(function ($) {

Drupal.behaviors.archibald_user_vcard = {
  attach: function (context, settings) {
   archibald_hook_user_edit_vcard();
  }
};

/**
 * @var temporery object cache to know where to save the currently choosen contributer
 */
var archibald_contributer_cur = {'role':'', 'name':'', 'entity':''};
var name = "";

function archibald_hook_user_edit_vcard() {
    name = $("#edit-field-user-vcard-und-0-value");
    $(name).hide();

    $("#edit-field-vcard-und-0-value-wrapper").remove();
    var inputWrapper = document.createElement("input");
    $(inputWrapper).attr("id", "edit-field-vcard-und-0-value-wrapper");
    $(inputWrapper).attr("name", "edit-field-vcard-und-0-value-wrapper");
    $(inputWrapper).addClass("form-text");
    $(inputWrapper).css("width", "100%");
    $(inputWrapper).unbind('click', archibald_user_edit_vcard_action_handler);
    $(inputWrapper).bind('click',   archibald_user_edit_vcard_action_handler);
    $(name).after(inputWrapper);

     if(name.val() != "") {
        $.ajax({
            type: 'POST',
            url: '/archibald_contributer/get/'+name.val(),
            success: function(response, status) {
              if(response != "") {
                  $(inputWrapper).val(response.firstname+" "+response.lastname+" "+response.organisation);
              }
            },
            dataType: 'json'
          });
    }

    $('.form_contributer_add_cancel').unbind('click', archibald_contributer_add_form_cancel_handler);
    $('.form_contributer_add_cancel').bind('click',   archibald_contributer_add_form_cancel_handler);

    $('.archibald_contributer_choose').unbind('click', archibald_contributer_choose_handle);
    $('.archibald_contributer_choose').bind('click',   archibald_contributer_choose_handle);

    $('.archibald_contributer_reset').unbind('click', archibald_contributer_reset_handle);
    $('.archibald_contributer_reset').bind('click',   archibald_contributer_reset_handle);

    // if we add a new one we will show the whole list afterwards and choose one with this tag
    $('.archibald_contributer_choose_this').each( archibald_contributer_choose_handle );

    $('.archibald_contriberter_page').each(function() {
     $(this).unbind('click',   archibald_contributer_page_link_handle);
     $(this).bind('click', archibald_contributer_page_link_handle);
    });
}

/**
 * event handler for clicking on contribute name field
 */
function archibald_user_edit_vcard_action_handler() {
      Drupal.CTools.Modal.show({ modalTheme: 'archibaldModalDialog' });

      var contributer = $(this).parents('.archibald_life_cycle_contribute_item');
      archibald_contributer_cur.name    = $(this);
      //archibald_contributer_cur.entity  = $('input[type=hidden][name$="\\[entity\\]"]',  contributer);
      archibald_contributer_cur.entity  = $('edit-field-vcard-und-0-value',  contributer);


      $.ajax({
        type: 'POST',
        url: '/archibald_contributer/chooser/ajax',
        data: {},
        //data: {entity:archibald_contributer_cur.entity.val(), self_lom_id:$('input[type=hidden][name=lom_id]').val()},
        success: function(response, status) {
          for (var i in response) {
            if (response[i]['command'] && Drupal.ajax.prototype.commands[response[i]['command']]) {
              Drupal.ajax.prototype.commands[response[i]['command']](Drupal.ajax, response[i], status);
            }
          }
        },
        dataType: 'json'
      });

}


/**
 * handler for add form cancel button
 */
function archibald_contributer_add_form_cancel_handler() {
      $.ajax({
        type: 'POST',
        url: '/archibald_contributer/chooser/ajax',
        success: function(response, status) {
          for (var i in response) {
            if (response[i]['command'] && Drupal.ajax.prototype.commands[response[i]['command']]) {
              Drupal.ajax.prototype.commands[response[i]['command']](Drupal.ajax, response[i], status);
            }
          }
        },
        dataType: 'json'
      });

      return false;
}

/**
 * handler for chosse contribute item
 */
function archibald_contributer_choose_handle() {
    archibald_contributer_cur.entity.val(  $(this).attr('contributer_id') );
    archibald_contributer_cur.name.val(    $(".archibald_contributer_list_name").html() );

    $("#edit-field-user-vcard-und-0-value").val($(this).attr('contributer_id'));
    $("#edit-field-vcard-und-0-value-wrapper").val($(".archibald_contributer_list_name").html());
    modalContentClose();
    return false;
}

/**
 * handler for reset contribute item
 */
function archibald_contributer_reset_handle() {
    archibald_contributer_cur.entity.val("");
    archibald_contributer_cur.name.val("");
    modalContentClose();
    return false;
}

/**
 * handle contriber overlay pager
 */
function archibald_contributer_page_link_handle() {
 $.ajax({
    type: 'GET',
    url: $(this).attr('href'),
    success: function(response, status) {
     $('#archibald_choose_contributer_search_result').html(response);
     Drupal.attachBehaviors('#modalContent .modal-content');
    },
    dataType: 'html'
 });

 return false;
}

/**
 * Provide the HTML to create the modal dialog.
 */
Drupal.theme.prototype.archibaldModalDialog = function () {
    var html = ''
    html += '  <div id="ctools-modal">'
    html += '    <div class="ctools-modal-content">' // panels-modal-content
    html += '      <div class="modal-header">';
    html += '        <a class="close" href="#">';
    html +=            Drupal.t('Close') + ' <img src="' + Drupal.settings.archibald.urls.module_base_path + '/images/close.png" border="0" />';
    html += '        </a>';
    html += '        <span id="modal-title" class="modal-title">&nbsp;</span>';
    html += '      </div>';
    html += '      <div id="modal-content" class="modal-content">';
    html += '      </div>';
    html += '    </div>';
    html += '  </div>';

    return html;
}

})(jQuery);