<?php

/**
 * @file
 * archibald_content_view.tpl.php
 * Display detail page of a lom ressource
 *
 * - $lom: ArchibaldLom Object
 * - $lom_title: ArchibaldLom general.title as string
 * - $lom_description: ArchibaldLom general.description as string (uncutted)
 * - $preview_image_fid: ArchibaldLom technical.preview_image Image fid (file id)
 * - $lifecycle_contributers: An multi array like (array( array('role', 'firstname', 'lastname') ))
 * - $is_part: an array with the same values as above (without is_part and has_part array)
 * - $has_part: an array with the same values as above (without is_part and has_part array)
 *
 */


global $language;

print $preview_image_img;

print $company_logo;

if (function_exists('archibald_ratings_show')):
  print archibald_ratings_show($lom->lomId);
endif;

//."<br />";
print check_plain($lom_description);

/**
 $return_vals = array();
 foreach ($lom->getGeneral()->getCoverage() as $langstring) {
   $return_vals[] = check_plain(ArchibaldLom::getLangstringText($langstring));
 }
 print implode(', ', $return_vals);
 */
print '<div class="clear"></div>';
?>
</div>
<!-- /wboxinfo -->

<div class="wbox archibald_view_info_blocks">

  <div class="details">
    <p><a href="JavaScript:void(0);" id="archibald_view_general" class="btndetails inactive remember_choice"><span><?php print t('General information'); ?></span></a></p>
    <div style="display: block;" class="detailscontainer archibald_view_general">

      <table class="view_general">
<?php foreach ($contributers_grouped as $role => $contributers) { ?>
          <tr>
            <td width="172"><?php print archibald_get_term_by_key($role, 'lc_cont_role'); ?></td>
            <td>
          <?php
            foreach ($contributers as $contributer_id => $array):
              print '<div class="contributer contributer_' . $role . '" contributer_id="' . $contributer_id . '">';
              $name = trim($array['vcard']->lastname . ', ' . $array['vcard']->firstname . '; ' . $array['vcard']->organization, ' ,;');
              $query = trim($array['vcard']->firstname . ' ' . $array['vcard']->lastname . ' ' . $array['vcard']->organization);
              print l($name, 'archibald', array('query' => array('query' => 'author:"' . $query . '"')));
              print '</div>';
            endforeach; ?>
            </td>
          </tr>
            <?php } ?>
        <tr>
          <td><?php print t('Version'); ?></td>
          <td>
            <?php if (empty($version)): ?>
              -
            <?php else: ?>
              <?php print $version; ?>
            <?php endif; ?>
          </td>
        </tr>
        <tr>
          <td><?php print t('Language'); ?></td>
          <td>
            <?php
            $return_vals = array();
            foreach ($lom->getGeneral()->getLanguage() as $langstring):
              $return_vals[] = archibald_get_language_by_code($langstring);
            endforeach;
            print implode(', ', $return_vals);
            ?>
          </td>
        </tr>
        <tr>
          <td><?php print t('Tags'); ?></td>
          <td>
          <?php
          $return_vals = array();
          foreach ($lom->getGeneral()->getKeyword() as $langstring):
            $val = ArchibaldLom::getLangstringText($langstring, '', TRUE);
            if (!empty($val)):
              $val = l($val, 'archibald', array('query' => array('query' => 'keywords:"' . $val . '"')));
              $return_vals[] = $val;
            endif;
          endforeach;
          if (empty($return_vals)):
            print '-';
          else:
            print implode('<br />', $return_vals);
          endif; ?>
          ?>
          </td>
        </tr>
        <tr>
          <td><?php print t('Coverage'); ?></td>
          <td>
          <?php
          $return_vals = array();
          foreach ($lom->getGeneral()->getCoverage() as $langstring):
            $val = ArchibaldLom::getLangstringText($langstring, '', TRUE);
            if (!empty($val)):
              $val = l($val, 'archibald', array('query' => array('query' => 'coverage:"' . $val . '"')));
              $return_vals[] = $val;
            endif;
          endforeach;
          if (empty($return_vals)):
            print '-';
          else:
            print implode('<br />', $return_vals);
          endif; ?>
          ?>
          </td>
        </tr>
      </table>



    </div>
  </div>

  <div class="details">
    <p><a href="JavaScript:void(0);" id="archibald_view_education" class="btndetails inactive remember_choice"><span><?php print t('Educational information'); ?></span></a></p>
    <div style="display: block;" class="detailscontainer archibald_view_education">



      <table class="view_education">
        <tr>
          <td width="172"><?php print t('Educational description'); ?></td><td><?php print check_plain(ArchibaldLom::getLangstringText($lom->getEducation()->getDescription())); ?></td>
        </tr>
        <tr>
          <td><?php print t('Learning resource type'); ?></td><td>
          <?php
          foreach ($lom->getEducation()->getLearningResourceType() as $voc):
            $value = $voc->getValue();
            $value_human = $value;
            switch ($voc->getSource()):
              case 'LOMv1.0':
              case 'LOM-CHv1.0':
              case 'LREv3.0':
                $value_human = archibald_get_term_by_key($value, 'learning_resourcetype');
                break;
            endswitch;
            print l($value_human, 'archibald', array('query' => array('query' => 'learning_resourcetype:"' . $value . '"'))) . '<br />';
          endforeach;
          ?>
          </td>
        </tr>
        <tr>
          <td ><?php print t('Intended end user role'); ?></td><td >
          <?php
          $enduser_roles = $lom->getEducation()->getIntendedEndUserRole();
          if (empty($enduser_roles)):
            print '-';
          else:
            foreach ($enduser_roles as $voc):
              $value = $voc->getValue();
              $value_human = $value;
              switch ($voc->getSource()):
                case 'LOMv1.0':
                case 'LOM-CHv1.0':
                case 'LREv3.0':
                  $value_human = archibald_get_term_by_key($value, 'intended_enduserrole');
                  break;
              endswitch;
              print l($value_human, 'archibald', array('query' => array('query' => 'intendet_enduserrole:"' . $value . '"'))) . '<br />';
            endforeach;
          endif;
          ?>
          </td>
        </tr>

        <tr>
          <td ><?php print t('Typical age range'); ?></td><td>
            <?php print $typical_age_range; ?>
          </td>
        </tr>
        <tr>
          <td><?php print t('Difficulty'); ?></td><td><?php
          $value = $lom->getEducation()->getDifficult()->getValue();
          if (empty($value)):
            print '-';
          else:
            $value_human = $value;
            switch ($lom->getEducation()->getDifficult()->getSource()):
              case 'LOMv1.0':
              case 'LOM-CHv1.0':
              case 'LREv3.0':
                $value_human = archibald_get_term_by_key($value, 'difficulty');
                break;
            endswitch;
            print l($value_human, 'archibald', array('query' => array('query' => 'difficulty:"' . $value . '"')));
          endif;
          ?></td>
        </tr>
        <tr>
          <td><?php print t('Typical learning time'); ?></td><td><?php print archibald_get_education_typical_lerning_time($lom->getEducation()->getTypicalLearningTime()->getDurationIn('minutes')); ?></td>
        </tr>

      </table>



    </div>
  </div>

  <div class="details">
    <p><a href="JavaScript:void(0);" id="archibald_view_curriculum" class="btndetails inactive remember_choice"><span><?php print t('Curricula'); ?></span></a></p>
    <div style="display: block;" class="detailscontainer archibald_view_curriculum">

      <table class="view_curriculum">
        <tr>
          <td width="172"><?php print t('Context'); ?></td><td>
          <?php
          foreach ($lom->getEducation()->getContext() as $voc):
            $value = $voc->getValue();
            $value_human = $value;
            switch ($voc->getSource()):
              case 'LOMv1.0':
              case 'LOM-CHv1.0':
              case 'LREv3.0':
                $value_human = archibald_get_term_by_key($value, 'education_context');
                break;
            endswitch;
            print l($value_human, 'archibald', array('query' => array('query' => 'education_context:"' . $value . '"'))) . '<br />';
          endforeach;
          ?>
          </td>
        </tr>
      </table>

      <?php
      foreach ($curriculums as $cur_name => $curriculum):
        $tmp = (array) $curriculum['entrys'];
        if (!empty($tmp)):
          drupal_add_css(drupal_get_path('module', 'archibald') . '/css/curriculum_' . $cur_name . '.css');
          ?>
          <strong><?php print $curriculum['name']; ?></strong>
          <hr />
          <?PHP
          print theme('archibald_content_view_curriculum_' . $cur_name, array('entrys' => $curriculum['entrys']));
        endif;
      endforeach;
      ?>


    </div>
  </div>

  <div class="details">
    <p><a href="JavaScript:void(0);" id="archibald_view_access" class="btndetails inactive remember_choice"><span><?php print t('Access to resource'); ?></span></a></p>
    <div style="display: block;" class="detailscontainer archibald_view_access">

      <strong><?php print t('Rights'); ?></strong>
      <hr />
      <table class="view_access">
        <tr>
          <td width="172"><?php print t('Cost'); ?></td><td><?php print t($lom->getRights()->getCost()->getValue()); ?></td>
        </tr>
        <tr>
          <td><?php print t('Copyright and other restrictions'); ?></td><td><?php print t($lom->getRights()->getCopyrightAndOtherRestrictions()->getValue()); ?></td>
        </tr>
        <tr>
          <td><?php print t('Licence'); ?></td>
          <td>
            <?php print $lizenz; ?>
          </td>
        </tr>
      </table>

      <strong><?php print t('Technical requirements'); ?></strong>
      <hr />
      <table class="view_access">
        <!--
        <tr>
            <td width="172"><?php print t('Format'); ?></td><td>
        <?php
        $formats = $lom->getTechnical()->getFormat();
        if (empty($formats)):
          print '-';
        else:
          foreach ($formats as $format):
            print $format . '<br />';
          endforeach;
        endif;
        ?>
            </td>
        </tr>
        <tr>
            <td><?php print t('Size'); ?></td><td><?php print $lom->getTechnical()->getSizeFormated(); ?></td>
        </tr>
        -->
        <tr>
          <td width="172"><?php print t('Technical requirements'); ?></td><td><?php
          $other_plattform_requirements = ArchibaldLom::getLangstringText($lom->getTechnical()->getOtherPlattformRequirements());
          if (empty($other_plattform_requirements)):
            print '-';
          else:
            print $other_plattform_requirements;
          endif;
          ?></td>
        </tr>
        <tr>
          <td width="172"><?php print t('Location'); ?></td><td><?php
          $location = $lom->getTechnical()->getLocation(0);
          if (empty($location)):
            print '-';
          else:
            print check_plain($location);
          endif;
          ?></td>
        </tr>
      </table>
      <strong><?php print t('Reference to resources'); ?></strong>
      <hr />
      <?php
      $identifiers = $lom->getGeneral()->getIdentifier();
      if (count($identifiers) > 0):
        print "<table>";

        foreach ($identifiers as $id => $identifier):
          print theme('archibald_lom_identifier', array('identifier' => $identifier));
        endforeach;
        print "</table>";
      endif;
      ?>
    </div>
  </div>

<?php if (count($is_part) > 0 || count($has_part) > 0) { ?>
    <div class="details">
      <p><a href="JavaScript:void(0);" id="archibald_view_related" class="btndetails inactive remember_choice"><span><?php print t('Related'); ?></span></a></p>
      <div style="display: block;" class="detailscontainer archibald_view_related">

        <?php if (count($is_part) > 0): ?>
          <strong><?php print t("Is part of:"); ?></strong>
          <?php
          foreach ($is_part as $lom_content):
            print "<div class='archibald_content_overview_row'>\n";
            $class = 'archibald_content_overview_row_content';
            if (!empty($lom_content['preview_image_fid'])):
              $file = file_load((INT) $lom_content['preview_image_fid']);
              print theme('image_style', array('style_name' => 'archibald_preview', 'path' => $file->uri, 'getsize' => FALSE, 'attributes' => array('fid' => $file->fid, 'class' => 'left_image')));
              $class .= ' archibald_corc_has_img';

              if (drupal_strlen($lom_content['lom_title']) > 49):
                $lom_content['lom_title'] = drupal_substr($lom_content['lom_title'], 0, 45) . ' ...';
              endif;
            else:
              if (drupal_strlen($lom_content['lom_title']) > 59):
                $lom_content['lom_title'] = drupal_substr($lom_content['lom_title'], 0, 55) . ' ...';
              endif;
            endif;
            print "  <div class='$class'>\n";
            print "      <h3>" . l($lom_content['lom_title'], 'archibald/' . $lom_content['lom']->lom_id) . "</h3>\n";
            print "      <div class=\"description\">" . truncate_utf8($lom_content['lom_description'], 360, TRUE, TRUE) . "</div>\n";
            print "  </div\n>";
            print "</div>\n";
            print "<div class='clear'></div>\n";
          endforeach;
          ?>
          <br />
        <?php endif; ?>
        <?php if (count($has_part) > 0) { ?>
          <strong><?php print t("Has part of:"); ?></strong>
          <?php
          foreach ($has_part as $lom_content):
            print "<div class='archibald_content_overview_row'>\n";
            $class = 'archibald_content_overview_row_content';
            if (!empty($lom_content['preview_image_fid'])):
              $file = file_load((INT) $lom_content['preview_image_fid']);
              print theme('image_style', array('style_name' => 'archibald_preview', 'path' => $file->uri, 'getsize' => FALSE, 'attributes' => array('fid' => $file->fid, 'class' => 'left_image')));
              $class .= ' archibald_corc_has_img';

              if (drupal_strlen($lom_content['lom_title']) > 49):
                $lom_content['lom_title'] = drupal_substr($lom_content['lom_title'], 0, 45) . ' ...';
              endif;
            else:
              if (drupal_strlen($lom_content['lom_title']) > 59):
                $lom_content['lom_title'] = drupal_substr($lom_content['lom_title'], 0, 55) . ' ...';
              endif;
            endif;
            print "  <div class='$class'>\n";
            print "      <h3>" . l($lom_content['lom_title'], 'archibald/' . $lom_content['lom']->lom_id) . "</h3>\n";
            print "      <div class=\"description\">" . truncate_utf8($lom_content['lom_description'], 360, TRUE, TRUE) . "</div>\n";
            print "  </div\n>";
            print "</div>\n";
            print "<div class='clear'></div>\n";
          endforeach;
          ?>

        <?php } ?>
      </div>
    </div>
<?php } ?>

  <?PHP
// comments module is enabled
if (function_exists('archibald_comments_paged_list')):
?>
    <div class="details">
      <p><a href="JavaScript:void(0);" name="comment-show" id="archibald_view_comments" class="btndetails inactive remember_choice"><span><?php print t('Comments'); ?></span></a></p>
      <div style="display: block;" class="detailscontainer archibald_view_comments commentbox commentContainer">

  <?php
      print archibald_comments_paged_list($lom->lom_id);
      if (user_access('create archibald comments')):
        print archibald_comments_form();
      endif;
   ?>

      </div>
    </div>
<?php endif; ?>

  <small><?php
print t(
  'This description was recorded by @first_editor at @first_date, last updated at @last_date',
  array(
    '@first_editor' => $additional['first']['username'],
    '@first_date' => $additional['first']['save_time'],
    '@last_date' => $additional['last']['save_time'],
  )
);
?></small>

</div>

<?php
$identifiers = $lom->getGeneral()->getIdentifier();
  if (count($identifiers) > 1 || count($usefull_ressource_links) != count($identifiers)) {
  print '<div class="ressource_dialog">';
  print '  <div class="title">' . t('Resource') . ' <span id="close_dialog"><img border="0" src="' . base_path() . drupal_get_path('module', 'archibald') . '/images/close.png" align="absmiddle" /></span></div>';
  print '    <div class="content">';
  foreach ($identifiers as $id => $identifier):
    print ' - ';
    if ($identifier->catalog != 'URL'):
      print t($identifier->catalog) . ': ';
    endif;
    print theme('archibald_lom_identifier', array('identifier' => $identifier, 'just_link' => TRUE)) . '<br />';
  endforeach;
  print '  </div></div>';
}
?>


<script type="text/javascript">
  (function ($) {
    $(function() {
      var ressources = $(".ressource_link > a");
      if (ressources.length > 1) {
        $(".preview_image_img").click(function() {
          if ($(".ressource_dialog").css("display") == "block") {
            $(".ressource_dialog").hide();
          }
          else {
            $(".ressource_dialog").show();
          }
        });
      }

      $("#close_dialog").click(function() {
        $(".ressource_dialog").hide();
      });
    });
  })(jQuery);
</script>

